function [x1, x2, val, grd1, grd2, hes11, hes12, hes22, xi1, xi2, ...
	  eltime, est, maxError, Txi1, Txi2, Tx1, Tx2, fxi1] ...
    = main(n, tg, M, funct_, grd, hes, xrange, yrange,family)

tic
if (strcmp(family, 'Xu'))
  [xi1,xi2,wxi]=xupts(n+1);
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = xu2(n,xi1,xi2,wxi,f);
elseif (strcmp(family, 'XuSP'))
  [xi1,xi2,wxi] = xupts(n+1, 'TL');
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = xu2(n,xi1,xi2,wxi,f);
elseif (strcmp(family, 'Padua1'))
  [xi1,xi2,wxi]=padpts1(n);
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = pad2(n, xi1, xi2, wxi, f);
elseif (strcmp(family, 'Padua2'))
  [xi1,xi2,wxi]=padpts2(n);
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = pad2(n, xi1, xi2, wxi, f);
elseif (strcmp(family, 'Padua3'))
  [xi1,xi2,wxi]=padpts3(n);
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = pad2(n, xi1, xi2, wxi, f);
elseif (strcmp(family, 'Padua4'))
  [xi1,xi2,wxi]=padpts4(n);
  f = feval(funct_,((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2,...
	((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2);
  [C0,est] = pad2(n, xi1, xi2, wxi, f);
else
  error(strcat(['Unknown point type: ' family]));
end
[x1,x2]=tgpts(tg, M);
grd1=0;
grd2=0;
hes11=0;
hes12=0;
hes22=0;
[val,Tx1,Tx2]=xx2val(C0,n,x1,x2);

%% hessian switches gradient on
if (hes==1)
  grd=1;
end

%% compute gradient
if (grd==1)
  [grd1,grd2,Tx1prime,Tx2prime]=xhi2grd(C0,n,x1,x2,Tx1,Tx2);
  grd1=2*grd1/(xrange(2)-xrange(1));
  grd2=2*grd2/(yrange(2)-yrange(1));
end

%% compute hessian
if (hes==1)
  [hes11,hes12,hes22]=xhi2hes(C0,n,x1,x2,Tx1,Tx2,Tx1prime,Tx2prime);
  hes11=4*hes11/(xrange(2)-xrange(1))^2;
  hes12=4*hes12/((xrange(2)-xrange(1))*(yrange(2)-yrange(1)));
  hes22=4*hes22/(yrange(2)-yrange(1))^2;
end
eltime=toc;
x1=((xrange(2)-xrange(1))*x1+(xrange(2)+xrange(1)))/2;
x2=((yrange(2)-yrange(1))*x2+(yrange(2)+yrange(1)))/2;
xi1=((xrange(2)-xrange(1))*xi1+(xrange(2)+xrange(1)))/2;
xi2=((yrange(2)-yrange(1))*xi2+(yrange(2)+yrange(1)))/2;
maxError=max(abs(val-feval(funct_,x1,x2)));
